zoukankan      html  css  js  c++  java
  • 【搜索入门专题1】hdu1548 G



    A strange lift



    Problem Description
    There is a strange lift.The lift can stop can at every floor as you want, and there is a number Ki(0 <= Ki <= N) on every floor.The lift have just two buttons: up and down.When you at floor i,if you press the button "UP" , you will go up Ki floor,i.e,you will go to the i+Ki th floor,as the same, if you press the button "DOWN" , you will go down Ki floor,i.e,you will go to the i-Ki th floor. Of course, the lift can't go up high than N,and can't go down lower than 1. For example, there is a buliding with 5 floors, and k1 = 3, k2 = 3,k3 = 1,k4 = 2, k5 = 5.Begining from the 1 st floor,you can press the button "UP", and you'll go up to the 4 th floor,and if you press the button "DOWN", the lift can't do it, because it can't go down to the -2 th floor,as you know ,the -2 th floor isn't exist.
    Here comes the problem: when you are on floor A,and you want to go to floor B,how many times at least he has to press the button "UP" or "DOWN"?
     

    Input
    The input consists of several test cases.,Each test case contains two lines.
    The first line contains three integers N ,A,B( 1 <= N,A,B <= 200) which describe above,The second line consist N integers k1,k2,....kn.
    A single 0 indicate the end of the input.
     

    Output
    For each case of the input output a interger, the least times you have to press the button when you on floor A,and you want to go to floor B.If you can't reach floor B,printf "-1".
     

    Sample Input
    5 1 5 3 3 1 2 5 0
     

    Sample Output
    3


    题意:输入楼层数n和起始楼层startx和结束楼层endx,再输入每层楼的权值,从起始楼层startx开始,有两种选择,1:加上自身楼层权值w到w+start层:2:减去自身楼层权值w到start-w层。但是楼层数必须满足1~n层的范围。


    思路:BFS,从起始楼层开始,搜索能够上下到达的楼层,若满足条件,则加入队列进行搜索,直到找到目的楼层,每走过一层楼标记为1。


    易错点:end函数是c++里的,所以我用end存储结束楼层提交显示CE;每次取队头元素都要进行判断是否满足结束条件,否则MEL。

    据说还可以用Dijkstra和dp写    不过我自己还没有想到

    #include<stdio.h>
    #include<iostream>
    #include<string.h>
    #include<math.h>
    #include<queue>
    using namespace std;
    #define N 210
    
    int startx,endx;
    int n,i;
    int num[N];
    int book[N];//标记该点是否走过 
    int time;
    
    struct note{
    	int w;//层数的权值 
    	int step;//步数 
    	int x;//层数 
    };
    
    
    void BFS()
    {
    	memset(book,0,sizeof(book));
    	note head;//队列头元素 
    	note now_head,next1,next2;//能上的楼层和能下的楼层 
    	queue<note>Q;
    	head.step = 0;
    	head.w = num[startx];//从开始楼层步数为0 
    	head.x = startx;
    	book[startx] = 1;//标记为已走过 
    	Q.push(head);
    	while(!Q.empty())
    	{
    		now_head = Q.front() ;
    		Q.pop();
    		if(now_head.x == endx)//找到终止点,结束函数 
    		{
    			time = now_head.step ;
    			return;
    		}
    		//能上的楼层 
    		next1.x  = now_head.x + now_head.w ;
    		if(next1.x <= n&&!book[next1.x])
    		{
    			next1.w = num[next1.x];
    			next1.step = now_head.step + 1;
    			book[next1.x] = 1;
    			Q.push(next1); 
    		}
    		//能下的楼层 
    		next2.x  = now_head.x - now_head.w ;
    		if(next2.x >= 1&&!book[next2.x])
    		{
    			next2.w = num[next2.x ];
    			next2.step = now_head.step +1;
    			book[next2.x] = 1;
    			Q.push(next2); 
    		}
    	}
    	return ;
    }
    
    int main()
    {
    	while(scanf("%d",&n),n!=0)
    	{
    		time = -1;
    		scanf("%d%d",&startx,&endx);
    		for(i = 1; i <= n; i ++)
    			scanf("%d",&num[i]);
    		BFS();
    		if(time != -1)
    			printf("%d
    ",time);
    		else
    			printf("-1
    ");
    	}
    	return 0;
    }






    A strange lift

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 26708    Accepted Submission(s): 9616


    Problem Description
    There is a strange lift.The lift can stop can at every floor as you want, and there is a number Ki(0 <= Ki <= N) on every floor.The lift have just two buttons: up and down.When you at floor i,if you press the button "UP" , you will go up Ki floor,i.e,you will go to the i+Ki th floor,as the same, if you press the button "DOWN" , you will go down Ki floor,i.e,you will go to the i-Ki th floor. Of course, the lift can't go up high than N,and can't go down lower than 1. For example, there is a buliding with 5 floors, and k1 = 3, k2 = 3,k3 = 1,k4 = 2, k5 = 5.Begining from the 1 st floor,you can press the button "UP", and you'll go up to the 4 th floor,and if you press the button "DOWN", the lift can't do it, because it can't go down to the -2 th floor,as you know ,the -2 th floor isn't exist.
    Here comes the problem: when you are on floor A,and you want to go to floor B,how many times at least he has to press the button "UP" or "DOWN"?
     

    Input
    The input consists of several test cases.,Each test case contains two lines.
    The first line contains three integers N ,A,B( 1 <= N,A,B <= 200) which describe above,The second line consist N integers k1,k2,....kn.
    A single 0 indicate the end of the input.
     

    Output
    For each case of the input output a interger, the least times you have to press the button when you on floor A,and you want to go to floor B.If you can't reach floor B,printf "-1".
     

    Sample Input
    5 1 5 3 3 1 2 5 0
     

    Sample Output
    3
  • 相关阅读:
    XML组成部分
    XML语法
    XML概念
    HTTP协议:响应消息的数据格式---Response
    KM HDU 3718
    KM最大匹配 HDU 2255
    匈牙利算法
    母函数
    最长公共子序列 LCS
    hdu 4632 区间DP
  • 原文地址:https://www.cnblogs.com/hellocheng/p/7350096.html
Copyright © 2011-2022 走看看